package client;

import java.net.InetAddress;
import java.util.ArrayList;

public class Jeu {
	private ArrayList<Joueur> list_joueur;
	private Carte carte;
	private Grille grille;
	private int id_joueur;
	private FenetreJeu fen;
	private ThreadEcouteServeurUDP thread;
	
	private InetAddress addr;
	private int port;
	
	public Jeu(Carte carte, int id_joueur, ArrayList<Joueur> liste) {
		this.carte = carte;
		this.id_joueur = id_joueur;
		this.list_joueur = new ArrayList<Joueur>();
		int i;
		for (i=0;i<liste.size();i++)
		{
			Joueur tmp = liste.get(i);
			list_joueur.add(new Joueur(tmp.getId(), tmp.getType(), tmp.getNom(), tmp.getR(), tmp.getC()));
		}
		this.grille = new Grille(carte, list_joueur);
		//System.out.println("Jeu: \n"+grille.toString());
		fen = null;
	}
	
	public void ajouterJoueur(int id, char t, String nom, int r, int c) {
		list_joueur.add(new Joueur(id, t, nom, r, c));
		//grille.ajouterJoueur(id, r, c);
		grille = new Grille(carte, list_joueur);
		fen.setGrille(grille);
	}
	
	public boolean deplacerJoueurLocal(int d)
	{
		{//renvoie true si le d�placement est possible
			boolean envoi = false;
			int i, ar=0, ac=0;
			for (i=0; i<list_joueur.size(); i++) {
				if (list_joueur.get(i).getId()==id_joueur) {
					ar = list_joueur.get(i).getR();
					ac = list_joueur.get(i).getC();
				}
			}
			System.out.println("Ligne: " + ar + "Colonne: " + ac);
			//Joueur j = grille.getJoueur(id);
			//int l = j.getL();
			//int r = j.getC();
			int nr=ar,nc=ac;
			switch (d)
			{
			case 37:
			{//gauche
				if (carte.getVal(ar, ac-1)==1)
				{
					//this.deplacerJoueur(id, ar, ac-1);
					envoi =  true;
					nc=nc-1;
				}
				break;
			}
			case 38:
			{//haut
				if (carte.getVal(ar-1, ac)==1)
				{
					//this.deplacerJoueur(id, ar-1, ac);
					envoi = true;
					nr=ar-1;
				}
				break;
			}
			case 39:
			{//droite
				if (carte.getVal(ar, ac+1)==1)
				{
					//this.deplacerJoueur(id, ar, ac+1);
					envoi =  true;
					nc=ac+1;
				}
				break;
			}
			case 40:
			{//bas
				if (carte.getVal(ar+1, ac)==1)
				{
					//this.deplacerJoueur(id, ar+1, ac);
					envoi =  true;
					nr=ar+1;
				}
				break;
			}
			default:
			{
				envoi =  false;
			}
			}
			if (envoi)
			{
				String msg = "MVT:"+id_joueur+":"+nr+":"+nc;
				ThreadEnvoiUDP th = new ThreadEnvoiUDP(addr,port,msg);
				th.start();
			}
			return envoi;
		}
	}
	
	public void deplacerJoueur(int id, int r, int c) {
		int i;
		for (i=0; i<list_joueur.size(); i++) {
			if (list_joueur.get(i).getId()==id) {
				list_joueur.get(i).setR(r);
				list_joueur.get(i).setC(c);
			}
		}
		grille = new Grille(carte, list_joueur);
		fen.setGrille(grille);
		//grille.deplacerJoueur(id, r, c);
	}
	
	public void supprimerJoueur(int id) {
		int i, pos=0;
		for (i=0; i<list_joueur.size(); i++) {
			if (list_joueur.get(i).getId()==id) {
				pos=i;
			}
		}
		if (pos!=0)
		{
			System.out.println("Suppression du joueur "+id);
			list_joueur.remove(pos);
			grille = new Grille(carte, list_joueur);
			fen.setGrille(grille);
		}
		else
		{
			System.out.println("Joueur non trouv");
		}
	}

	public Grille getGrille() {
		return grille;
	}

	public FenetreJeu getFen() {
		return fen;
	}

	public void setFen(FenetreJeu fen) {
		this.fen = fen;
	}

	public ThreadEcouteServeurUDP getThread() {
		return thread;
	}

	public void setThread(ThreadEcouteServeurUDP thread) {
		this.thread = thread;
	}

	public InetAddress getAddr() {
		return addr;
	}

	public void setAddr(InetAddress addr) {
		this.addr = addr;
	}

	public int getPort() {
		return port;
	}

	public void setPort(int port) {
		this.port = port;
	}

	public int getId_joueur() {
		return id_joueur;
	}

	public void setId_joueur(int id_joueur) {
		this.id_joueur = id_joueur;
	}

}
